// testsys.v

// Generated using ACDS version 20.1 720

`timescale 1 ps / 1 ps
module testsys (
		input  wire  clk_clk,                      //                      clk.clk
		input  wire  reset_reset_n,                //                    reset.reset_n
		input  wire  uart_external_connection_rxd, // uart_external_connection.rxd
		output wire  uart_external_connection_txd, //                         .txd
		output wire  uart_irq_irq                  //                 uart_irq.irq
	);

	wire  [31:0] mm_master_bfm_0_m0_readdata;             // mm_interconnect_0:mm_master_bfm_0_m0_readdata -> mm_master_bfm_0:avm_readdata
	wire         mm_master_bfm_0_m0_waitrequest;          // mm_interconnect_0:mm_master_bfm_0_m0_waitrequest -> mm_master_bfm_0:avm_waitrequest
	wire  [31:0] mm_master_bfm_0_m0_address;              // mm_master_bfm_0:avm_address -> mm_interconnect_0:mm_master_bfm_0_m0_address
	wire         mm_master_bfm_0_m0_read;                 // mm_master_bfm_0:avm_read -> mm_interconnect_0:mm_master_bfm_0_m0_read
	wire         mm_master_bfm_0_m0_readdatavalid;        // mm_interconnect_0:mm_master_bfm_0_m0_readdatavalid -> mm_master_bfm_0:avm_readdatavalid
	wire  [31:0] mm_master_bfm_0_m0_writedata;            // mm_master_bfm_0:avm_writedata -> mm_interconnect_0:mm_master_bfm_0_m0_writedata
	wire         mm_master_bfm_0_m0_write;                // mm_master_bfm_0:avm_write -> mm_interconnect_0:mm_master_bfm_0_m0_write
	wire         mm_interconnect_0_uart_s1_chipselect;    // mm_interconnect_0:uart_s1_chipselect -> uart:chipselect
	wire  [15:0] mm_interconnect_0_uart_s1_readdata;      // uart:readdata -> mm_interconnect_0:uart_s1_readdata
	wire   [2:0] mm_interconnect_0_uart_s1_address;       // mm_interconnect_0:uart_s1_address -> uart:address
	wire         mm_interconnect_0_uart_s1_read;          // mm_interconnect_0:uart_s1_read -> uart:read_n
	wire         mm_interconnect_0_uart_s1_begintransfer; // mm_interconnect_0:uart_s1_begintransfer -> uart:begintransfer
	wire         mm_interconnect_0_uart_s1_write;         // mm_interconnect_0:uart_s1_write -> uart:write_n
	wire  [15:0] mm_interconnect_0_uart_s1_writedata;     // mm_interconnect_0:uart_s1_writedata -> uart:writedata

	altera_avalon_mm_master_bfm #(
		.AV_ADDRESS_W               (32),
		.AV_SYMBOL_W                (8),
		.AV_NUMSYMBOLS              (4),
		.AV_BURSTCOUNT_W            (3),
		.AV_READRESPONSE_W          (8),
		.AV_WRITERESPONSE_W         (8),
		.USE_READ                   (1),
		.USE_WRITE                  (1),
		.USE_ADDRESS                (1),
		.USE_BYTE_ENABLE            (0),
		.USE_BURSTCOUNT             (0),
		.USE_READ_DATA              (1),
		.USE_READ_DATA_VALID        (1),
		.USE_WRITE_DATA             (1),
		.USE_BEGIN_TRANSFER         (0),
		.USE_BEGIN_BURST_TRANSFER   (0),
		.USE_WAIT_REQUEST           (1),
		.USE_TRANSACTIONID          (0),
		.USE_WRITERESPONSE          (0),
		.USE_READRESPONSE           (0),
		.USE_CLKEN                  (0),
		.AV_CONSTANT_BURST_BEHAVIOR (1),
		.AV_BURST_LINEWRAP          (0),
		.AV_BURST_BNDR_ONLY         (1),
		.AV_MAX_PENDING_READS       (0),
		.AV_MAX_PENDING_WRITES      (0),
		.AV_FIX_READ_LATENCY        (1),
		.AV_READ_WAIT_TIME          (1),
		.AV_WRITE_WAIT_TIME         (0),
		.REGISTER_WAITREQUEST       (1),
		.AV_REGISTERINCOMINGSIGNALS (1),
		.VHDL_ID                    (0)
	) mm_master_bfm_0 (
		.clk                    (clk_clk),                          //       clk.clk
		.reset                  (~reset_reset_n),                   // clk_reset.reset
		.avm_address            (mm_master_bfm_0_m0_address),       //        m0.address
		.avm_readdata           (mm_master_bfm_0_m0_readdata),      //          .readdata
		.avm_writedata          (mm_master_bfm_0_m0_writedata),     //          .writedata
		.avm_waitrequest        (mm_master_bfm_0_m0_waitrequest),   //          .waitrequest
		.avm_write              (mm_master_bfm_0_m0_write),         //          .write
		.avm_read               (mm_master_bfm_0_m0_read),          //          .read
		.avm_readdatavalid      (mm_master_bfm_0_m0_readdatavalid), //          .readdatavalid
		.avm_burstcount         (),                                 // (terminated)
		.avm_begintransfer      (),                                 // (terminated)
		.avm_beginbursttransfer (),                                 // (terminated)
		.avm_byteenable         (),                                 // (terminated)
		.avm_arbiterlock        (),                                 // (terminated)
		.avm_lock               (),                                 // (terminated)
		.avm_debugaccess        (),                                 // (terminated)
		.avm_transactionid      (),                                 // (terminated)
		.avm_readid             (8'b00000000),                      // (terminated)
		.avm_writeid            (8'b00000000),                      // (terminated)
		.avm_clken              (),                                 // (terminated)
		.avm_response           (2'b00),                            // (terminated)
		.avm_writeresponsevalid (1'b0),                             // (terminated)
		.avm_readresponse       (8'b00000000),                      // (terminated)
		.avm_writeresponse      (8'b00000000)                       // (terminated)
	);

	testsys_uart uart (
		.clk           (clk_clk),                                 //                 clk.clk
		.reset_n       (reset_reset_n),                           //               reset.reset_n
		.address       (mm_interconnect_0_uart_s1_address),       //                  s1.address
		.begintransfer (mm_interconnect_0_uart_s1_begintransfer), //                    .begintransfer
		.chipselect    (mm_interconnect_0_uart_s1_chipselect),    //                    .chipselect
		.read_n        (~mm_interconnect_0_uart_s1_read),         //                    .read_n
		.write_n       (~mm_interconnect_0_uart_s1_write),        //                    .write_n
		.writedata     (mm_interconnect_0_uart_s1_writedata),     //                    .writedata
		.readdata      (mm_interconnect_0_uart_s1_readdata),      //                    .readdata
		.rxd           (uart_external_connection_rxd),            // external_connection.export
		.txd           (uart_external_connection_txd),            //                    .export
		.irq           (uart_irq_irq)                             //                 irq.irq
	);

	testsys_mm_interconnect_0 mm_interconnect_0 (
		.clk_main_clk_clk                                      (clk_clk),                                 //                                    clk_main_clk.clk
		.mm_master_bfm_0_clk_reset_reset_bridge_in_reset_reset (~reset_reset_n),                          // mm_master_bfm_0_clk_reset_reset_bridge_in_reset.reset
		.mm_master_bfm_0_m0_address                            (mm_master_bfm_0_m0_address),              //                              mm_master_bfm_0_m0.address
		.mm_master_bfm_0_m0_waitrequest                        (mm_master_bfm_0_m0_waitrequest),          //                                                .waitrequest
		.mm_master_bfm_0_m0_read                               (mm_master_bfm_0_m0_read),                 //                                                .read
		.mm_master_bfm_0_m0_readdata                           (mm_master_bfm_0_m0_readdata),             //                                                .readdata
		.mm_master_bfm_0_m0_readdatavalid                      (mm_master_bfm_0_m0_readdatavalid),        //                                                .readdatavalid
		.mm_master_bfm_0_m0_write                              (mm_master_bfm_0_m0_write),                //                                                .write
		.mm_master_bfm_0_m0_writedata                          (mm_master_bfm_0_m0_writedata),            //                                                .writedata
		.uart_s1_address                                       (mm_interconnect_0_uart_s1_address),       //                                         uart_s1.address
		.uart_s1_write                                         (mm_interconnect_0_uart_s1_write),         //                                                .write
		.uart_s1_read                                          (mm_interconnect_0_uart_s1_read),          //                                                .read
		.uart_s1_readdata                                      (mm_interconnect_0_uart_s1_readdata),      //                                                .readdata
		.uart_s1_writedata                                     (mm_interconnect_0_uart_s1_writedata),     //                                                .writedata
		.uart_s1_begintransfer                                 (mm_interconnect_0_uart_s1_begintransfer), //                                                .begintransfer
		.uart_s1_chipselect                                    (mm_interconnect_0_uart_s1_chipselect)     //                                                .chipselect
	);

endmodule
