// testsys_tb.v

// Generated using ACDS version 20.1 720

`timescale 1 ps / 1 ps
module testsys_tb (
	);

	wire        testsys_inst_clk_bfm_clk_clk;                          // testsys_inst_clk_bfm:clk -> [irq_mapper:clk, testsys_inst:clk_clk, testsys_inst_reset_bfm:clk, testsys_inst_uart_irq_bfm:clk]
	wire        testsys_inst_uart_external_connection_txd;             // testsys_inst:uart_external_connection_txd -> testsys_inst_uart_external_connection_bfm:sig_txd
	wire  [0:0] testsys_inst_uart_external_connection_bfm_conduit_rxd; // testsys_inst_uart_external_connection_bfm:sig_rxd -> testsys_inst:uart_external_connection_rxd
	wire        testsys_inst_reset_bfm_reset_reset;                    // testsys_inst_reset_bfm:reset -> [irq_mapper:reset, testsys_inst:reset_reset_n, testsys_inst_uart_irq_bfm:reset]
	wire        irq_mapper_receiver0_irq;                              // testsys_inst:uart_irq_irq -> irq_mapper:receiver0_irq
	wire  [0:0] testsys_inst_uart_irq_bfm_irq_irq;                     // irq_mapper:sender_irq -> testsys_inst_uart_irq_bfm:irq

	testsys testsys_inst (
		.clk_clk                      (testsys_inst_clk_bfm_clk_clk),                          //                      clk.clk
		.reset_reset_n                (testsys_inst_reset_bfm_reset_reset),                    //                    reset.reset_n
		.uart_external_connection_rxd (testsys_inst_uart_external_connection_bfm_conduit_rxd), // uart_external_connection.rxd
		.uart_external_connection_txd (testsys_inst_uart_external_connection_txd),             //                         .txd
		.uart_irq_irq                 (irq_mapper_receiver0_irq)                               //                 uart_irq.irq
	);

	altera_avalon_clock_source #(
		.CLOCK_RATE (100000000),
		.CLOCK_UNIT (1)
	) testsys_inst_clk_bfm (
		.clk (testsys_inst_clk_bfm_clk_clk)  // clk.clk
	);

	altera_avalon_reset_source #(
		.ASSERT_HIGH_RESET    (0),
		.INITIAL_RESET_CYCLES (50)
	) testsys_inst_reset_bfm (
		.reset (testsys_inst_reset_bfm_reset_reset), // reset.reset_n
		.clk   (testsys_inst_clk_bfm_clk_clk)        //   clk.clk
	);

	altera_conduit_bfm testsys_inst_uart_external_connection_bfm (
		.sig_rxd (testsys_inst_uart_external_connection_bfm_conduit_rxd), // conduit.rxd
		.sig_txd (testsys_inst_uart_external_connection_txd)              //        .txd
	);

	altera_avalon_interrupt_sink #(
		.ASSERT_HIGH_IRQ        (1),
		.AV_IRQ_W               (1),
		.ASYNCHRONOUS_INTERRUPT (0),
		.VHDL_ID                (0)
	) testsys_inst_uart_irq_bfm (
		.clk   (testsys_inst_clk_bfm_clk_clk),        //       clock_reset.clk
		.reset (~testsys_inst_reset_bfm_reset_reset), // clock_reset_reset.reset
		.irq   (testsys_inst_uart_irq_bfm_irq_irq)    //               irq.irq
	);

	altera_irq_mapper irq_mapper (
		.clk           (testsys_inst_clk_bfm_clk_clk),        //       clk.clk
		.reset         (~testsys_inst_reset_bfm_reset_reset), // clk_reset.reset
		.receiver0_irq (irq_mapper_receiver0_irq),            // receiver0.irq
		.sender_irq    (testsys_inst_uart_irq_bfm_irq_irq)    //    sender.irq
	);
	
	master_test_program #() umaster_test();

endmodule
